import stamp.util.history.*;
import stamp.core.*;
import stamp.util.text.*;

/**
 * Class to test SystemEepromHistory() class.
 *
 * @version 1.0, November 17, 2008
 * @author Peter Verkaik (verkaik6@zonnet.nl)
 */

public class SystemEepromHistory_test {

  static SystemEepromHistory log = new SystemEepromHistory(JavEE.allocate(18),18);
  static char[] buf = new char[256];
  static StringBuffer temp = new StringBuffer();

  static boolean printLog() {
    int len = log.readOldest(buf,255,0);
    if (len > 0) {
      Format.printf("<messages>\n");
      log.printArray(buf,len,0); //should print restored message after reset/powerup
      while (len > 0) {
        len = log.readNext(buf,255,0);
        log.printArray(buf,len,0); //should print restored message after reset/powerup
      }
      return true;
    }
    return false;
  }

  static void main() {
    int len;
    Format.printf("SystemEepromHistory_test program.\n");
    Format.printf("<eeprom message table>\n");
    log.printTable();
    if (printLog()) {
      temp.clear();
      Format.printf("add message RR\n");
      temp.append("RR");
      log.write(temp.toString().toCharArray(),temp.length(),0);
      Format.printf("<eeprom message table>\n");
      log.printTable();
      printLog();
    }
    else {
      Format.printf("add message PPPP\n");
      temp.append("PPPP");
      log.write(temp.toString().toCharArray(),temp.length(),0);
      printLog();
      temp.clear();
      Format.printf("add message QQQQ\n");
      temp.append("QQQQ");
      log.write(temp.toString().toCharArray(),temp.length(),0);
      printLog();
    }

    Format.printf("\nProgram finished.\n");
    while (true) {
    }
  }

}